## libengine-gost-openssl 3.0.1

=== libprov/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
project(libprov LANGUAGES C)
set(CMAKE_C_STANDARD 99)

if (NOT OPENSSL_FOUND)
  find_package(OpenSSL 3.0 REQUIRED)
endif()

add_library(libprov STATIC err.c)
set_target_properties(libprov PROPERTIES
  POSITION_INDEPENDENT_CODE ON
  OUTPUT_NAME "prov")
target_include_directories(libprov PUBLIC include)
target_link_libraries(libprov PRIVATE OpenSSL::Crypto)

=== debian/changelog ===
libengine-gost-openssl (3.0.1-2) unstable; urgency=medium

  * Add pkg-config to Build-Depends (Closes: #1014070) 

 -- Wartan Hachaturow <wart@debian.org>  Thu, 30 Jun 2022 15:02:22 +0300

libengine-gost-openssl (3.0.1-1) unstable; urgency=medium

  * Wohoo-my-gpg-key-works-again release
  * Upgrade to OpenSSL 3.0 engine branch, rename package
  * Fix for CVE-2022-29242 (Closes: #1012512)
  * Deprecate 1.1 package version.
  * Update debian/copyright

 -- Wartan Hachaturow <wart@debian.org>  Mon, 13 Jun 2022 00:38:39 +0300

libengine-gost-openssl1.1 (1.1.0.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * d/watch: Scan GitHub tags.

  [ Helmut Grohne ]
  * Fix openssl engine path for cross compilation (Closes: #966642).

  [ Simon Chopin ]
  * Stopgap patches for OpenSSL3 before migrating to provider API:
    - d/rules: downgrade deprecation errors to warnings to fix the build
      against OpenSSL 3 (Closes: #1006391)
    - d/p/OpenSSL3.patch: Fix several const-correctness issues introduced
      by OpenSSL 3 API changes.

 -- Bastian Germann <bage@debian.org>  Sat, 21 May 2022 00:33:51 +0200

libengine-gost-openssl1.1 (1.1.0.3-1) unstable; urgency=medium

  * New upstream version
  * Closes: #898823, #906734

 -- Wartan Hachaturow <wart@debian.org>  Sun, 16 Sep 2018 18:58:16 +0300

libengine-gost-openssl1.1 (1.1.0.1-1) unstable; urgency=low

  * Initial upload
  * Closes: #870625

 -- Wartan Hachaturow <wart@debian.org>  Fri, 11 Aug 2017 19:34:28 +0300

=== debian/control ===
Source: libengine-gost-openssl
Section: libs
Priority: optional
Maintainer: Wartan Hachaturow <wart@debian.org>
Build-Depends: debhelper (>= 13), cmake, libssl-dev, openssl, pkg-config
Standards-Version: 3.9.5
Homepage: https://github.com/gost-engine/engine
Vcs-Git: https://github.com/gost-engine/engine.git

Package: libengine-gost-openssl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libengine-gost-openssl1.1 (<< 3.0.1-1)
Replaces: libengine-gost-openssl1.1 (<< 3.0.1-1)
Provides: libengine-gost-openssl1.1
Description: Loadable module for openssl implementing GOST algorithms
 This package contains loadable module for openssl library, which
 implements (in software) Russian national standard (GOST) cryptography

Package: libengine-gost-openssl1.1
Section: oldlibs
Architecture: any
Depends: libengine-gost-openssl (= ${binary:Version}), ${misc:Depends}
Description: dummy package for upgrades from libengine-gost-openssl1.1
 Can be safely removed.

Package: gostsum
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Utility to compute GOST hashes
 This package contain utilities to compute GOST hashsums
 gostsum - computes GOST R 34.11-94 hash
 gost12sum - computes GOST R 34.11-2012 hash

## libengine-gost-openssl 3.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
project(gost-engine LANGUAGES C)

include(GNUInstallDirs)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckCSourceRuns)

enable_testing()

find_package(OpenSSL 3.0 REQUIRED)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build." FORCE)
endif()

if (NOT DEFINED OPENSSL_ROOT_DIR)
  get_filename_component(OPENSSL_ROOT_DIR ${OPENSSL_INCLUDE_DIR} DIRECTORY)
  message(STATUS "Setting OpenSSL root: ${OPENSSL_ROOT_DIR}")
endif()
find_program(OPENSSL_PROGRAM openssl
  PATHS ${OPENSSL_ROOT_DIR} PATH_SUFFIXES apps bin NO_DEFAULT_PATH)
message(STATUS "Found OpenSSL application: ${OPENSSL_PROGRAM}")
include_directories(${OPENSSL_INCLUDE_DIR})
set(OPENSSL_MODULES_DIR ${CMAKE_INSTALL_LIBDIR}/ossl-modules)

if (CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS_RELEASE -O2)
  set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb")
  set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -ggdb")
  add_compile_options(-Werror -Wall -Wno-unused-parameter -Wno-unused-function -Wno-missing-braces -Qunused-arguments -Wno-deprecated-declarations)
elseif(CMAKE_C_COMPILER_ID MATCHES "GNU")
  set(CMAKE_C_FLAGS_RELEASE -O2)
  set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb")
  set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -ggdb")
  add_compile_options(-Werror -Wall -Wno-unused-parameter -Wno-unused-function -Wno-missing-braces -Wno-error=unknown-pragmas -Wno-error=pragmas -Wno-deprecated-declarations)
elseif(CMAKE_C_COMPILER_ID MATCHES "MSVC")
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  add_definitions(-D_CRT_DEPRECATED_NO_WARNINGS)
  add_definitions(-D_CRT_NONSTDC_NO_WARNINGS)
  add_compile_options(/MP /WX /W4 /wd4100 /wd4267 /wd4206 /wd4706 /wd4244 /wd4115 /wd4996)
endif()

if (ASAN)
  message(STATUS "address sanitizer enabled")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -g3 -fno-omit-frame-pointer")
  set(SKIP_PERL_TESTS 1)
endif()

set(CMAKE_C_STANDARD 90)
CHECK_FUNCTION_EXISTS(clock_gettime HAVE_CLOCK_GETTIME_C)
CHECK_LIBRARY_EXISTS(rt clock_gettime "" HAVE_CLOCK_GETTIME_RT)
if(HAVE_CLOCK_GETTIME_RT AND NOT HAVE_CLOCK_GETTIME_C)
  set(CLOCK_GETTIME_LIB rt)
endif()

include (TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
 message(STATUS "BIG_ENDIAN")
else()
 message(STATUS "LITTLE_ENDIAN")
 add_definitions(-DL_ENDIAN)
endif()

check_c_source_runs("
  #ifdef _MSC_VER
  # include <intrin.h>
  #else
  # include <x86intrin.h>
  #endif
  int main(void) {
    unsigned long long x = -1, y = 1, r;
    unsigned char cf;
    cf = _addcarry_u64(1, x, y, &r);
    return !(cf == 1 && r == 1);
  }
  " ADDCARRY_U64)
if (ADDCARRY_U64)
  add_definitions(-DHAVE_ADDCARRY_U64)
endif()

check_c_source_runs("
  int main(void) {
    char buf[16] = { 0, 1, 2 };
    int *p = (int *)(buf + 1);
    int *q = (int *)(buf + 2);
    return (*p == *q);
  }
  " RELAXED_ALIGNMENT)
if (NOT RELAXED_ALIGNMENT)
  add_definitions(-DSTRICT_ALIGNMENT)
endif()

if(MSVC)
  set(BIN_DIRECTORY bin/$<CONFIG>/)
else()
  set(BIN_DIRECTORY bin)
endif()

set(OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${BIN_DIRECTORY})

#set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})

# Remove when https://gitlab.kitware.com/cmake/cmake/issues/18525 is addressed
set(OPENSSL_ENGINES_DIR "" CACHE PATH "OpenSSL Engines Directory")
if ("${OPENSSL_ENGINES_DIR}" STREQUAL "")
	include(FindPkgConfig)
	pkg_get_variable(OPENSSL_ENGINES_DIR libcrypto enginesdir)
	if ("${OPENSSL_ENGINES_DIR}" STREQUAL "")
		message( FATAL_ERROR "Unable to discover the OpenSSL engines directory. Provide the path using -DOPENSSL_ENGINES_DIR" )
	endif()
endif()

set(GOST_89_SOURCE_FILES
        gost89.c
        gost89.h
        )

set(GOST_HASH_SOURCE_FILES
        gosthash.c
        gosthash.h
        )

set(GOST_HASH_2012_SOURCE_FILES
        gosthash2012.c
        gosthash2012.h
        gosthash2012_const.h
        gosthash2012_precalc.h
        gosthash2012_ref.h
        gosthash2012_sse2.h
        )

set(GOST_GRASSHOPPER_SOURCE_FILES
        gost_grasshopper.h
        gost_grasshopper_core.h
        gost_grasshopper_core.c
        gost_grasshopper_defines.h
        gost_grasshopper_defines.c
        gost_grasshopper_math.h
        gost_grasshopper_galois_precompiled.c
        gost_grasshopper_precompiled.c
        gost_grasshopper_cipher.h
        gost_grasshopper_cipher.c
        )

set(GOST_ERR_SOURCE_FILES
        e_gost_err.c
        e_gost_err.h
        )

set(GOST_CORE_SOURCE_FILES
        gost_ameth.c
        gost_pmeth.c
        gost_ctl.c
        gost_asn1.c
        gost_crypt.c
        gost_keywrap.c
        gost_keywrap.h
        gost_md.c
        gost_md2012.c
        gost_omac.c
        gost_omac_acpkm.c
        gost_gost2015.c
        gost_lcl.h
        gost_params.c
        gost_keyexpimp.c
        )

set(GOST_EC_SOURCE_FILES
        gost_ec_keyx.c
        gost_ec_sign.c
        ecp_id_GostR3410_2001_CryptoPro_A_ParamSet.c
        ecp_id_GostR3410_2001_CryptoPro_B_ParamSet.c
        ecp_id_GostR3410_2001_CryptoPro_C_ParamSet.c
        ecp_id_GostR3410_2001_TestParamSet.c
        ecp_id_tc26_gost_3410_2012_256_paramSetA.c
        ecp_id_tc26_gost_3410_2012_512_paramSetA.c
        ecp_id_tc26_gost_3410_2012_512_paramSetB.c
        ecp_id_tc26_gost_3410_2012_512_paramSetC.c
        )

set (GOST_OMAC_SOURCE_FILES
        gost_omac.c
        gost_omac_acpkm.c
        )

set(GOST_LIB_SOURCE_FILES
        ${GOST_CORE_SOURCE_FILES}
        ${GOST_89_SOURCE_FILES}
        ${GOST_HASH_SOURCE_FILES}
        ${GOST_HASH_2012_SOURCE_FILES}
        ${GOST_GRASSHOPPER_SOURCE_FILES}
        ${GOST_EC_SOURCE_FILES}
        ${GOST_OMAC_SOURCE_FILES}
        )

set(GOST_ENGINE_SOURCE_FILES
        gost_eng.c
        )

set(GOST_PROV_SOURCE_FILES
        gost_prov.c
        gost_prov_cipher.c
        gost_prov_digest.c
        gost_prov_mac.c
        )

set(TEST_ENVIRONMENT_COMMON
        CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}
        PERL5LIB=${CMAKE_CURRENT_SOURCE_DIR}/test
        OPENSSL_PROGRAM=${OPENSSL_PROGRAM}
        OPENSSL_CRYPTO_LIBRARY=${OPENSSL_CRYPTO_LIBRARY}
        )

set(TEST_ENVIRONMENT_ENGINE
        ${TEST_ENVIRONMENT_COMMON}
        OPENSSL_ENGINES=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        OPENSSL_CONF=${CMAKE_CURRENT_SOURCE_DIR}/test/engine.cnf
        )

set(TEST_ENVIRONMENT_PROVIDER
        ${TEST_ENVIRONMENT_COMMON}
        OPENSSL_MODULES=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        OPENSSL_CONF=${CMAKE_CURRENT_SOURCE_DIR}/test/provider.cnf
        )

add_executable(test_digest test_digest.c)
target_link_libraries(test_digest OpenSSL::Crypto)
add_test(NAME digest-with-engine COMMAND test_digest)
set_tests_properties(digest-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
add_test(NAME digest-with-provider COMMAND test_digest)
set_tests_properties(digest-with-provider
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")

add_executable(test_ciphers test_ciphers.c)
target_link_libraries(test_ciphers OpenSSL::Crypto)
add_test(NAME ciphers-with-engine COMMAND test_ciphers)
set_tests_properties(ciphers-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
add_test(NAME ciphers-with-provider COMMAND test_ciphers)
set_tests_properties(ciphers-with-provider
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")

# test_curves is an internals testing program, it doesn't need a test env
add_executable(test_curves test_curves.c)
target_link_libraries(test_curves gost_core gost_err)
add_test(NAME curves COMMAND test_curves)

add_executable(test_params test_params.c)
target_link_libraries(test_params OpenSSL::Crypto)
add_test(NAME parameters-with-engine COMMAND test_params)
set_tests_properties(parameters-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")

add_executable(test_derive test_derive.c)
target_link_libraries(test_derive OpenSSL::Crypto)
add_test(NAME derive-with-engine COMMAND test_derive)
set_tests_properties(derive-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")

add_executable(test_sign test_sign.c)
target_link_libraries(test_sign OpenSSL::Crypto)
add_test(NAME sign/verify-with-engine COMMAND test_sign)
set_tests_properties(sign/verify-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")

add_executable(test_tls test_tls.c)
target_link_libraries(test_tls OpenSSL::SSL)
add_test(NAME TLS-with-engine COMMAND test_tls)
set_tests_properties(TLS-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")

add_executable(test_context test_context.c)
target_link_libraries(test_context OpenSSL::Crypto)
add_test(NAME context-with-engine COMMAND test_context)
set_tests_properties(context-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
add_test(NAME context-with-provider COMMAND test_context)
set_tests_properties(context-with-provider
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")

# test_keyexpimp is an internals testing program, it doesn't need a test env
add_executable(test_keyexpimp test_keyexpimp.c)
#target_compile_definitions(test_keyexpimp PUBLIC -DOPENSSL_LOAD_CONF)
target_link_libraries(test_keyexpimp gost_core gost_err)
add_test(NAME keyexpimp COMMAND test_keyexpimp)

# test_gost89 is an internals testing program, it doesn't need a test env
add_executable(test_gost89 test_gost89.c)
target_link_libraries(test_gost89 gost_core gost_err)
add_test(NAME gost89 COMMAND test_gost89)

add_executable(test_mgm test_mgm.c)
target_link_libraries(test_mgm OpenSSL::Crypto)
add_test(NAME mgm-with-engine COMMAND test_mgm)
set_tests_properties(mgm-with-engine
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
add_test(NAME mgm-with-provider COMMAND test_mgm)
set_tests_properties(mgm-with-provider
  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")

if(NOT SKIP_PERL_TESTS)
    execute_process(COMMAND perl -MTest2::V0 -e ""
       ERROR_QUIET RESULT_VARIABLE MISSING_TEST2_V0)
    find_program(HAVE_PROVE NAMES prove)
    if(NOT MISSING_TEST2_V0 AND HAVE_PROVE)
	add_test(NAME engine
	    COMMAND prove --merge -PWrapOpenSSL ${CMAKE_CURRENT_SOURCE_DIR}/test :: engine)
	set_tests_properties(engine PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
	add_test(NAME provider
	    COMMAND prove --merge -PWrapOpenSSL ${CMAKE_CURRENT_SOURCE_DIR}/test :: provider)
	set_tests_properties(provider PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")
    else()
        message(STATUS "No Test2::V0 perl module (engine and provider tests skipped)")
    endif()
endif()

if(NOT MSVC)
  add_executable(sign benchmark/sign.c)
  target_link_libraries(sign gost_core gost_err ${CLOCK_GETTIME_LIB})
endif()

# All that may need to load just built engine will have path to it defined.
set(BINARY_TESTS_TARGETS
        test_digest
        test_ciphers
        test_curves
        test_params
        test_derive
        test_sign
        test_context
        test_keyexpimp
        test_gost89
        test_tls
        test_mgm
        )
set_property(TARGET ${BINARY_TESTS_TARGETS} APPEND PROPERTY COMPILE_DEFINITIONS ENGINE_DIR="${OUTPUT_DIRECTORY}")

add_library(gost_core STATIC ${GOST_LIB_SOURCE_FILES})
set_target_properties(gost_core PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_link_libraries(gost_core PRIVATE OpenSSL::Crypto)
add_library(gost_err STATIC ${GOST_ERR_SOURCE_FILES})
set_target_properties(gost_err PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_link_libraries(gost_err PRIVATE OpenSSL::Crypto)

# The GOST engine in module form
add_library(gost_engine MODULE ${GOST_ENGINE_SOURCE_FILES})
# Set the suffix explicitly to adapt to OpenSSL's idea of what a
# module suffix should be
set_target_properties(gost_engine PROPERTIES
  PREFIX "" OUTPUT_NAME "gost" SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})

=== debian/changelog ===
libengine-gost-openssl (3.0.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:46:19 +1100

libengine-gost-openssl (3.0.2-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:22:54 +0000

libengine-gost-openssl (3.0.2-1) unstable; urgency=medium

  * New upstream version
  * Includes fix for gcc13 (Closes: #1037726)

 -- Wartan Hachaturow <wart@debian.org>  Mon, 14 Aug 2023 23:59:32 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libengine-gost-openssl
 Section: libs
 Priority: optional
-Maintainer: Wartan Hachaturow <wart@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Wartan Hachaturow <wart@debian.org>
 Build-Depends: debhelper (>= 13), cmake, libssl-dev, openssl, pkg-config
 Standards-Version: 3.9.5
 Homepage: https://github.com/gost-engine/engine

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1

export DEB_CFLAGS_MAINT_APPEND = -Wno-error=deprecated-declarations

include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

OPENSSL_ENGINE_DIR=$(shell openssl version -e |sed -e 's/^[^.]*"//' -e 's/".*$$//' -e 's/$(DEB_BUILD_MULTIARCH)/$(DEB_HOST_MULTIARCH)/')
OPENSSL_MODULE_DIR=$(shell openssl version -m |sed -e 's/^[^.]*"//' -e 's/".*$$//' -e 's/$(DEB_BUILD_MULTIARCH)/$(DEB_HOST_MULTIARCH)/')
# main packaging script based on dh7 syntax
%:
	dh $@ 

# Please also look if there are files or directories which have a
# different copyright/license attached and list them here.
# Please avoid to pick license terms that are more restrictive than the
# packaged work, as it may make Debian's contributions unacceptable upstream.

## libengine-gost-openssl 3.0.3%2Bgit20251212.7f6d61a

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,9 @@
 %:
 	dh $@ 
 
+override_dh_auto_test:
+	dh_auto_test --no-parallel
+
 # Please also look if there are files or directories which have a
 # different copyright/license attached and list them here.
 # Please avoid to pick license terms that are more restrictive than the

## libengine-gost-openssl 3.0.3+git20251212.7f6d61a

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 enable_testing()
 
-find_package(OpenSSL 3.0 REQUIRED)
+find_package(OpenSSL 3.4 REQUIRED)
 
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
   message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
@@ -29,12 +29,12 @@
   set(CMAKE_C_FLAGS_RELEASE -O2)
   set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb")
   set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -ggdb")
-  add_compile_options(-Werror -Wall -Wno-unused-parameter -Wno-unused-function -Wno-missing-braces -Qunused-arguments -Wno-deprecated-declarations)
+  add_compile_options(-Werror -Wall -Wno-unused-parameter -Wno-unused-function -Wno-missing-braces -Qunused-arguments -Wno-deprecated-declarations -Wno-error=\#warnings)
 elseif(CMAKE_C_COMPILER_ID MATCHES "GNU")
   set(CMAKE_C_FLAGS_RELEASE -O2)
   set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb")
   set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -ggdb")
-  add_compile_options(-Werror -Wall -Wno-unused-parameter -Wno-unused-function -Wno-missing-braces -Wno-error=unknown-pragmas -Wno-error=pragmas -Wno-deprecated-declarations)
+  add_compile_options(-Werror -Wall -Wno-unused-parameter -Wno-unused-function -Wno-missing-braces -Wno-error=unknown-pragmas -Wno-error=pragmas -Wno-deprecated-declarations -Wno-error=cpp)
 elseif(CMAKE_C_COMPILER_ID MATCHES "MSVC")
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
   add_definitions(-D_CRT_DEPRECATED_NO_WARNINGS)
@@ -45,6 +45,10 @@
 if (ASAN)
   message(STATUS "address sanitizer enabled")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -g3 -fno-omit-frame-pointer")
+  set(SKIP_PERL_TESTS 1)
+endif()
+
+if (CMAKE_SYSTEM_NAME STREQUAL "Windows")
   set(SKIP_PERL_TESTS 1)
 endif()
 
@@ -204,15 +208,25 @@
 
 set(GOST_PROV_SOURCE_FILES
         gost_prov.c
+        gost_prov.h
         gost_prov_cipher.c
         gost_prov_digest.c
         gost_prov_mac.c
+        gost_prov_keymgmt.c
+        gost_prov_encoder.c
+        gost_prov_signature.c
+        gost_prov_decoder.c
+        gost_prov_keyexch.c
+        gost_prov_tls.c
+        gost_prov_tls.h
         )
 
 set(TEST_ENVIRONMENT_COMMON
+        TLS13_PATCHED_OPENSSL=${TLS13_PATCHED_OPENSSL}
         CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}
         PERL5LIB=${CMAKE_CURRENT_SOURCE_DIR}/test
         OPENSSL_PROGRAM=${OPENSSL_PROGRAM}
+        OPENSSL_MODULES=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
         OPENSSL_CRYPTO_LIBRARY=${OPENSSL_CRYPTO_LIBRARY}
         )
 
@@ -247,6 +261,13 @@
   PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")
 
 # test_curves is an internals testing program, it doesn't need a test env
+
+add_executable(test_ecdhe test_ecdhe.c)
+target_link_libraries(test_ecdhe gost_core gost_err)
+add_test(NAME ecdhe COMMAND test_ecdhe)
+set_tests_properties(ecdhe
+  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
+
 add_executable(test_curves test_curves.c)
 target_link_libraries(test_curves gost_core gost_err)
 add_test(NAME curves COMMAND test_curves)
@@ -295,14 +316,23 @@
 target_link_libraries(test_gost89 gost_core gost_err)
 add_test(NAME gost89 COMMAND test_gost89)
 
-add_executable(test_mgm test_mgm.c)
-target_link_libraries(test_mgm OpenSSL::Crypto)
-add_test(NAME mgm-with-engine COMMAND test_mgm)
-set_tests_properties(mgm-with-engine
-  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
-add_test(NAME mgm-with-provider COMMAND test_mgm)
-set_tests_properties(mgm-with-provider
-  PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")
+if(TLS13_PATCHED_OPENSSL)
+  add_executable(test_mgm test_mgm.c)
+  target_link_libraries(test_mgm OpenSSL::Crypto)
+  add_test(NAME mgm-with-engine COMMAND test_mgm)
+  set_tests_properties(mgm-with-engine
+    PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_ENGINE}")
+  add_test(NAME mgm-with-provider COMMAND test_mgm)
+  set_tests_properties(mgm-with-provider
+    PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")
+  set_property(TARGET test_mgm APPEND PROPERTY COMPILE_DEFINITIONS ENGINE_DIR="${OUTPUT_DIRECTORY}")
+
+  add_executable(test_tls13handshake test_tls13handshake.c)
+  target_link_libraries(test_tls13handshake OpenSSL::Crypto OpenSSL::SSL)
+  add_test(NAME test-tls13handshake-with-provider COMMAND test_tls13handshake)
+  set_tests_properties(test-tls13handshake-with-provider
+    PROPERTIES ENVIRONMENT "${TEST_ENVIRONMENT_PROVIDER}")
+endif()
 
 if(NOT SKIP_PERL_TESTS)
     execute_process(COMMAND perl -MTest2::V0 -e ""
@@ -325,32 +355,3 @@
   target_link_libraries(sign gost_core gost_err ${CLOCK_GETTIME_LIB})
 endif()
 
-# All that may need to load just built engine will have path to it defined.
-set(BINARY_TESTS_TARGETS
-        test_digest
-        test_ciphers
-        test_curves
-        test_params
-        test_derive
-        test_sign
-        test_context
-        test_keyexpimp
-        test_gost89
-        test_tls
-        test_mgm
-        )
-set_property(TARGET ${BINARY_TESTS_TARGETS} APPEND PROPERTY COMPILE_DEFINITIONS ENGINE_DIR="${OUTPUT_DIRECTORY}")
-
-add_library(gost_core STATIC ${GOST_LIB_SOURCE_FILES})
-set_target_properties(gost_core PROPERTIES POSITION_INDEPENDENT_CODE ON)
-target_link_libraries(gost_core PRIVATE OpenSSL::Crypto)
-add_library(gost_err STATIC ${GOST_ERR_SOURCE_FILES})
-set_target_properties(gost_err PROPERTIES POSITION_INDEPENDENT_CODE ON)
-target_link_libraries(gost_err PRIVATE OpenSSL::Crypto)
-
-# The GOST engine in module form
-add_library(gost_engine MODULE ${GOST_ENGINE_SOURCE_FILES})
-# Set the suffix explicitly to adapt to OpenSSL's idea of what a
-# module suffix should be
-set_target_properties(gost_engine PROPERTIES
-  PREFIX "" OUTPUT_NAME "gost" SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})

=== docker/Makefile ===

OK           := \e[1;32mOK\e[0m
FAIL         := \e[1;31mFAIL\e[0m
PRINT_RESULT := echo '${OK}' || echo '${FAIL}'

#
# for git tag used tag name as version
# else version is name of branch or "unknown" if no .git repo
# also you can replace VERSION value using environment variables: 
#   VERSION=latest make help
# 
VERSION ?= $(shell \
	if git describe --tags --exact-match >/dev/null 2>&1; then \
		git describe --tags --exact-match; \
	else \
		git branch --show-current 2>/dev/null || echo "unknown"; \
	fi \
)
DOCKER_IMAGE := gost-engine

RELEASES     := alpine debian 
# rockylinux -- unsuitable version "3.2.2", but required is at least "3.4"

.PHONY: help $(RELEASES)

help:
	@ echo "The GOST Engine version: $(VERSION)"
	@ echo "Available targets: help $(RELEASES)"
	@ echo "--"
	@ echo "To build images use:"
	@ for r in $(RELEASES); do \
		echo " > make $$r => $(DOCKER_IMAGE):$(VERSION)-$$r"; \
	done	


update:
	git submodule update --init



$(RELEASES): update
	docker build \
		--file Dockerfile.$@ \
		--tag $(DOCKER_IMAGE):$(VERSION)-$@ \
		..
	@ echo 
	@ echo "\e[1;37m => Checking the OpenSSL version\e[0m"
	@ docker run -it --rm $(DOCKER_IMAGE):$(VERSION)-$@ openssl version -v
	@ echo "$(OK)"
	@ echo "\e[1;37m => Checking the GOST ciphers\e[0m"
	@ docker run -it --rm $(DOCKER_IMAGE):$(VERSION)-$@ openssl ciphers | tr ':' '\n' | grep 'GOST' && $(PRINT_RESULT)

=== libprov/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18 FATAL_ERROR)
cmake_policy(SET
  # This allows setting C_VISIBILITY_PRESET on static libraries, for
  # those who want to do this with the libprov library
  CMP0063 NEW
)
project(libprov LANGUAGES C)
set(CMAKE_C_STANDARD 99)

if (NOT OPENSSL_FOUND)
  find_package(OpenSSL 3.0 REQUIRED)
endif()

add_library(libprov STATIC err.c num.c)
set_target_properties(libprov PROPERTIES
  POSITION_INDEPENDENT_CODE ON
  OUTPUT_NAME "prov")
target_include_directories(libprov PUBLIC include)
target_include_directories(libprov PRIVATE ${OPENSSL_INCLUDE_DIR})

=== debian/changelog ===
libengine-gost-openssl (3.0.3+git20251212.7f6d61a-1) unstable; urgency=medium

  * Remove debian/compat to comply with new debhelper rules.
  * Latest commit from upstream git repository
  * Cross-builds to s390x, (Closes: #1054922)
  * Builds with cmake 4 (Closes: #1113146)
  * Fix race condition on test phase (Closes: #1115372)

 -- Wartan Hachaturow <wart@debian.org>  Tue, 06 Jan 2026 21:24:39 +0300

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: libengine-gost-openssl
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Wartan Hachaturow <wart@debian.org>
-Build-Depends: debhelper (>= 13), cmake, libssl-dev, openssl, pkg-config
+Maintainer: Wartan Hachaturow <wart@debian.org>
+Build-Depends: debhelper-compat (= 13), cmake, libssl-dev, openssl, pkg-config
 Standards-Version: 3.9.5
 Homepage: https://github.com/gost-engine/engine
 Vcs-Git: https://github.com/gost-engine/engine.git
